\section{Monitoring and Logging}
Centralized logging is important for application and system insights. When building and maintaining enterprise applications, chances are high that the are running on multiple hosts. 

\subsection{Promotheus}
Is a powerfull open-source tool for collecting metric data from applications and also actively querying it. Scrapes real-time metrics from applications at a regular intervall. Scrapes by sending HTTP requests to metric endpoints. Collects data from hosts and services.

Provides a powerfull data model an query language (PromQL).  Allows you to analyze how infrastructure and applications are performing.  Allows you to analyze how infrastructure and applications are performing.Has client libraries to instrument custom apps written in Go, Java, Python, Node.js. Kubernetes and Docker are already instrumented with Prometheus client libraries.

\paragraph{What is Prometheus good at?} \hfill \\
It doesn't require any special software on applications including container images to collect metrics. Allows applications to not have to use resources pushing metrics. Handles interrputs (service failure, etc) well. If an app goes down, Promotheus notes that it can't retrieve data. Provides a Pushgateway when pulling metrics is not workable (such as with a short-term run). All Prometheus components can be run in containers.

\paragraph{How Prometheus is intended to be used} \hfill \\
Can be used to monitor most anything and analyze performance: databases, VMs, servers, applications. Works well for collecting end evaluating metrics.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{prometheus}
  \caption{Prometheus Architecture}
\end{figure}

\subsubsection{Service Discovery} 
Is the standard method for finding endpoints to scrape them for the metrics. Prometheus needs to know where the apps are running. Prometheus has integrations with common service discovery functions, including: Kubernetes, Consul, EC2, Generic one.

Prometheus allows for configuring how metadata from service discovery is mapped to monitoring targets and labels using relabeling.

\subsection{Grafana}
Can use Prometheus as the data source to display the recorded data. b 
